use v6.c;
use GLib::Raw::Types;

unit package GIO::TypeClass;

our %classType is export = (
    "GIO::SettingsBackend" => "GSettingsBackend",
    "GIO::DataInputStream" => "GDataInputStream",
    "GIO::MenuModel" => "GMenuModel",
    "GIO::DBus::Server" => "GDBusServer",
    "GIO::UnixOutputStream" => "GUnixOutputStream",
    "GIO::Permission" => "GPermission",
    "GIO::MenuAttributeIter" => "GMenuAttributeIter",
    "GIO::ListStore" => "GListStore",
    "GIO::ApplicationCommandLine" => "GApplicationCommandLine",
    "GIO::FilenameCompleter" => "GFilenameCompleter",
    "GIO::AppInfoMonitor" => "GAppInfoMonitor",
    "GIO::Stream" => "GIOStream",
    "GIO::UnixSocketAddress" => "GUnixSocketAddress",
    "GIO::ConverterInputStream" => "GConverterInputStream",
    "GIO::ProxyAddressEnumerator" => "GProxyAddressEnumerator",
    "GIO::SimpleAction" => "GSimpleAction",
    "GIO::DataOutputStream" => "GDataOutputStream",
    "GIO::SimpleActionGroup" => "GSimpleActionGroup",
    "GIO::FileEnumerator" => "GFileEnumerator",
    "GIO::TlsConnection" => "GTlsConnection",
    "GIO::SocketAddress" => "GSocketAddress",
    "GIO::TcpWrapperConnection" => "GTcpWrapperConnection",
    "GIO::Application" => "GApplication",
    "GIO::NetworkService" => "GNetworkService",
    "GIO::ThreadedSocketService" => "GThreadedSocketService",
    "GIO::SocketListener" => "GSocketListener",
    "GIO::InetAddressMask" => "GInetAddressMask",
    "GIO::BytesIcon" => "GBytesIcon",
    "GIO::DesktopAppInfo" => "GDesktopAppInfo",
    "GIO::SocketClient" => "GSocketClient",
    "GIO::Notification" => "GNotification",
    "GIO::SimpleProxyResolver" => "GSimpleProxyResolver",
    "GIO::MountOperation" => "GMountOperation",
    "GIO::FileInputStream" => "GFileInputStream",
    "GIO::TcpConnection" => "GTcpConnection",
    "GIO::SocketAddressEnumerator" => "GSocketAddressEnumerator",
    "GIO::UnixMount" => "GUnixMountEntry",
    "GIO::MenuItem" => "GMenuItem",
    "GIO::NetworkAddress" => "GNetworkAddress",
    "GIO::FileAttributeInfoList" => "GFileAttributeInfoList",
    "GIO::FileInfo" => "GFileInfo",
    "GIO::LaunchContext" => "GAppLaunchContext",
    "GIO::MemoryInputStream" => "GMemoryInputStream",
    "GIO::DBus::AuthObserver" => "GDBusAuthObserver",
    "GIO::VFS" => "GVfs",
    "GIO::SocketService" => "GSocketService",
    "GIO::VolumeMonitor" => "GVolumeMonitor",
    "GIO::SettingsSchema" => "GSettingsSchema",
    "GIO::Resource" => "GResource",
    "GIO::ZlibDecompressor" => "GZlibDecompressor",
    "GIO::SocketConnection" => "GSocketConnection",
    "GIO::FileMonitor" => "GFileMonitor",
    "GIO::FileIOStream" => "GFileIOStream",
    "GIO::Cancellable" => "GCancellable",
    "GIO::TlsCertificate" => "GTlsCertificate",
    "GIO::DBus::MethodInvocation" => "GDBusMethodInvocation",
    "GIO::CharsetConverter" => "GCharsetConverter",
    "GIO::TlsPassword" => "GTlsPassword",
    "GIO::UnixInputStream" => "GUnixInputStream",
    "GIO::InetAddress" => "GInetAddress",
    "GIO::DBus::ActionGroup" => "GDBusActionGroup",
    "GIO::Settings" => "GSettings",
    "GIO::Task" => "GTask",
    "GIO::UnixConnection" => "GUnixConnection",
    "GIO::Emblem" => "GEmblem",
    "GIO::FileIcon" => "GFileIcon",
    "GIO::DBus::Proxy" => "GDBusProxy",
    "GIO::ConverterOutputStream" => "GConverterOutputStream",
    "GIO::UnixFDMessage" => "GUnixFDMessage",
    "GIO::SocketControlMessage" => "GSocketControlMessage",
    "GIO::DBus::InterfaceSkeleton" => "GDBusInterfaceSkeleton",
    "GIO::PropertyAction" => "GPropertyAction",
    "GIO::MenuLinkIter" => "GMenuLinkIter",
    "GIO::UnixCredentialsMessage" => "GUnixCredentialsMessage",
    "GIO::FileOutputStream" => "GFileOutputStream",
    "GIO::SimplePermission" => "GSimplePermission",
    "GIO::InetSocketAddress" => "GInetSocketAddress",
    "GIO::Resolver" => "GResolver",
    "GIO::BufferedOutputStream" => "GBufferedOutputStream",
    "GIO::Credentials" => "GCredentials",
    "GIO::EmblemedIcon" => "GEmblemedIcon",
    "GIO::ZlibCompressor" => "GZlibCompressor",
    "GIO::Menu" => "GMenu",
    "GIO::SrvTarget" => "GSrvTarget",
    "GIO::ProxyAddress" => "GProxyAddress",
    "GIO::FileAttributeMatcher" => "GFileAttributeMatcher",
    "GIO::BufferedInputStream" => "GBufferedInputStream",
    "GIO::Socket" => "GSocket",
    "GIO::TlsInteraction" => "GTlsInteraction",
    "GIO::TlsDatabase" => "GTlsDatabase",
    "GIO::MemoryOutputStream" => "GMemoryOutputStream",
).Hash